## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           free42
Epoch:          1
Version:        3.1.12
Release:        %autorelease
License:        GPL-2.0-only AND BSD-3-Clause
Summary:        42S Calculator Simulator
URL:            https://www.thomasokken.com/free42/
Source:         https://www.thomasokken.com/free42/upstream/free42-nologo-%{version}.tgz
Patch0:         free42-makefile.patch
Patch1:         free42-intel-lib-arches.patch

BuildRequires:  gcc-c++
BuildRequires:  gtk3-devel
BuildRequires:  alsa-lib-devel
BuildRequires:  ImageMagick
BuildRequires:  desktop-file-utils
BuildRequires:  libappstream-glib
BuildRequires:  make

Provides:       bundled(IntelRDFPMathLib) = 2.1

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

%description
Free42 is a complete re-implementation of the 42S calculator and the
82240 printer.  It was written from scratch, without using any HP code.

%prep
%autosetup -p1 -n free42-nologo-%{version}

%build
cd gtk
# inteldecimal F128_CFLAGS uses this instead of CFLAGS
export CFLAGS_OPT="%{optflags}"
# make fails when using %{?_smp_mflags}
make BCD_MATH=1 AUDIO_ALSA=1

convert icon-48x48.xpm icon-48x48.png
sed -i -e 's/IvoryBlack/#231F20/' icon-128x128.xpm
convert icon-128x128.xpm icon-128x128.png

cat <<EOF >free42.desktop
[Desktop Entry]
Name=Free42
GenericName=Free42 calculator simulator
Exec=free42dec
Icon=free42
Terminal=false
Type=Application
Categories=Utility;Calculator;
EOF

cat <<EOF >free42.appdata.xml
<?xml version="1.0" encoding="UTF-8"?>
<component type="desktop-application">
    <id>com.thomasokken.free42</id>
    <name>Free42</name>
    <summary>42S Calculator Simulator</summary>
    <metadata_license>FSFAP</metadata_license>
    <project_license>GPL-2.0</project_license>
    <description>
        <p>
            Free42 is a complete re-implementation of the 42S calculator and the
            82240 printer.  It was written from scratch, without using any HP code.
        </p>
    </description>
    <launchable type="desktop-id">free42.desktop</launchable>
    <provides>
        <binary>free42dec</binary>
    </provides>
    <content_rating type="oars-1.1"/>
    <developer_name>Thomas Okken</developer_name>
    <releases>
        <release version="%{version}" date="%(date +%F -r %{SOURCE0})" />
    </releases>
    <url type="homepage">https://www.thomasokken.com/free42/</url>
</component>
EOF

%install
install -D -p -m 755 gtk/free42dec %{buildroot}%{_bindir}/free42dec
install -D -p -m 644 gtk/icon-48x48.png %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
install -D -p -m 644 gtk/icon-128x128.png %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/%{name}.png
install -D -p -m 644 gtk/free42.desktop %{buildroot}%{_datadir}/applications/%{name}.desktop
install -D -p -m 644 gtk/free42.appdata.xml %{buildroot}%{_metainfodir}/%{name}.appdata.xml

%check
desktop-file-validate %{buildroot}/%{_datadir}/applications/%{name}.desktop
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/%{name}.appdata.xml

%files
%doc CREDITS HISTORY README
%license COPYING gtk/IntelRDFPMathLib20U1/eula.txt
%{_bindir}/free42dec
%{_datadir}/applications/%{name}.desktop
%{_datadir}/icons/hicolor/*/*/%{name}.png
%{_metainfodir}/%{name}.appdata.xml

%changelog
## START: Generated by rpmautospec
* Thu Jan 16 2025 Fedora Release Engineering <releng@fedoraproject.org> - 1:3.1.12-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Wed Dec 25 2024 Filipe Rosset <rosset.filipe@gmail.com> - 1:3.1.12-1
- Update to 3.1.12

* Fri Nov 01 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.9-1
- Update to 3.1.9

* Wed Jul 17 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1:3.1.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Fri May 17 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.8-1
- Update to 3.1.8

* Thu Apr 11 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.7-1
- Update to 3.1.7

* Wed Mar 27 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.6-1
- Update to 3.1.6

* Thu Mar 07 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.5-1
- Update to 3.1.5

* Sun Feb 11 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.4-1
- Update to 3.1.4

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1:3.1.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1:3.1.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Thu Jan 18 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.3-1
- Update to 3.1.3

* Fri Dec 01 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.2-1
- Update to 3.1.2

* Thu Nov 30 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1.1-1
- Update to 3.1.1

* Wed Nov 15 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.1-1
- Update to 3.1

* Fri Aug 11 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.0.21-1
- Update to 3.0.21

* Fri Aug 11 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.0.20-3
- Disable i686 build

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1:3.0.20-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Apr 20 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.0.20-1
- Update to 3.0.20

* Mon Apr 10 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.0.19-1
- Update to 3.0.19

* Sun Mar 19 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.0.18-1
- Update to 3.0.18

* Mon Feb 06 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1:3.0.17-1
- Update to 3.0.17

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jan 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Thu Jul 04 2019 Filipe Rosset <rosset.filipe@gmail.com> - 1:1.4.77-9
- -Wno-narrowing to fix FTBFS on rawhide fixes rhbz#1603998 and rhbz#1674894

* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Aug 02 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1:1.4.77-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Dec 18 2015 Eric Smith <brouhaha@fedoraproject.org> 1:1.4.77-1
- Revert to 1.4.77 and bump epoch, due to problems with Intel decimal
  floating point library. See also package review #1098820 for idfpml.
- Changed / to @ in second sed command because optflags may contain a
  slash in a path.

* Sun Jul  5 2015 Peter Robinson <pbrobinson@fedoraproject.org> 1.5.5-1
- Update to 1.5.5, fix FTBFS

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat May 17 2014 Eric Smith <eric@brouhaha.com> 1.5-1
- Update to latest upstream.

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.77-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Jun 06 2013 Eric Smith <eric@brouhaha.com> 1.4.77-1
- Update to latest upstream.

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.74-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.74-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sun Jul 08 2012 Eric Smith <eric@brouhaha.com> 1.4.74-1
- Update to latest upstream.

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.70-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sat Oct 08 2011 Eric Smith <eric@brouhaha.com> 1.4.70-1
- Update to latest upstream.
- Removed BuildRoot, clean, defattr, etc.

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.66-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Apr 21 2010 Eric Smith <eric@brouhaha.com> 1.4.66-1
- update to latest upstream

* Sun Mar 28 2010 Eric Smith <eric@brouhaha.com> 1.4.62-2
- Edit Makefile to add -lX11 to libs, necessary for Fedora 13. Not sure why
  I didn't need that for Fedora 12. Sed command from package review by
  Martin Gieseking.
- Edit Makefile to define CXXFLAGS based on RPM optflags. Sed command from
  package review by Martin Gieseking.

* Sat Mar 27 2010 Eric Smith <eric@brouhaha.com> 1.4.62-1
- update to latest upstream

* Sun Jan 31 2010 Eric Smith <eric@brouhaha.com> 1.4.61-1
- initial version

## END: Generated by rpmautospec
